/*==========================================================================
*
*  Example_1 - demo application
*  by Branislav Lehotsky
*  Demonstration of using BonbliotFramework (c)
*  - is showing background and flying sprites, parametrisation via menu 
*
*  Example_1 - demontran apka
*  Branislav Lehotsk
*  Demontruje pouitie BonbliotFramework (c)
*  - zobraz pozadie a lietajce sprajty, parametrizacia cez menu
*
*==========================================================================
*/
#include <ddraw.h>     //Direct Draw 
#include <mmsystem.h>  //koli LPWAVEFORMATEX v <dsound.h> a.i.
#include <dsound.h>    //Direct Sound

//---------------------- //hlavicka hlavnej kniznice, FrameWork by Bonbliot (c)
//#include "..\_BonbliotFramework_v3_1\DBonbliotFW.h"
#include "DBonbliotFW.h"    
//----------------------

#define IDC_BTN_DLG_SSF    100

#define IDC_BTN_OK         200
#define IDC_BTN_CANCEL     201
#define IDI_BTN_OK         202 
#define IDI_BTN_CANCEL     203

#define IDC_RADIO_1        204
#define IDC_RADIO_2        205
#define IDC_RADIO_3        206

#define IDC_DUIM           207
#define IDC_DUIB           208
#define IDC_DUIE           209
#define IDC_DUIR_THM       210
#define IDC_DUIR_SPRITES   211

const double PI2 = double(6.28318531);

bool pravedole;

bf_CDas_Surface  emoticons_srf;
//int POLX = 500;
int status_SSF = 2;    //stav tlacitka stop/slow/fast

//----------------------------------------------------------------
// Emoticon
//----------------------------------------------------------------
class CEmoticon : public bf_CPosIcon
{
public:
  double vx, vy;
  double xx, yy;

  CEmoticon(bf_CIcon *p_icon);
  void Activate();
  void Reset();
};

//----------------------------------------------------------------
// Konstruktor
//----------------------------------------------------------------
CEmoticon::CEmoticon(bf_CIcon* p_icon) : bf_CPosIcon(NULL, bf_Get_SX(), bf_Get_SY(), p_icon)
{
    vx = 0; vy = 0;
    xx = x; yy = y;
    Reset();
}

//----------------------------------------------------------------
// Aktivacia, krok
//----------------------------------------------------------------
void CEmoticon::Activate()
{
  int change = int ( (double(rand()) / RAND_MAX) * 30 );   //nahodne cislo <0,30>
  if (change == 15) Reset();   //nahodne zmenit smer

  if (status_SSF == 2) //slow
  {
    xx += vx;
    yy += vy;
  }
  if (status_SSF == 3) //fast
  {
    xx += 3*vx;
    yy += 3*vy;
  }

  int test_sir = faza.SIR;
  int test_vys = faza.VYS;
  int maxx = bf_Get_MAXX();
  int maxy = bf_Get_MAXY();

  if (xx > (maxx - test_sir)) { xx = maxx - test_sir; vx = -vx; };
  if (xx < 0) { xx = 0; vx = -vx; };
  if (yy > (maxy - test_vys)) { yy = maxy - test_vys; vy = -vy; };
  if (yy < 0) { yy = 0; vy = -vy; };

  x = int(xx);
  y = int(yy);
}

//----------------------------------------------------------------
// Resetne vektor rychlosti, nahodne
//----------------------------------------------------------------
void CEmoticon::Reset()
{
  int V = 5;
  double alf = (double(rand()) / RAND_MAX) * PI2;   //nahodny uhol <0,2pi>
  vx = cos(alf) * V;
  vy = sin(alf) * V;
}


//----------------------------------------------------------------
// App
//----------------------------------------------------------------
class CMyApp : public bf_CAppScreen
{
public:
  bf_CButton * m_btn_SSF;
  bf_CLabel * m_label_1;

  bf_CDUI  *m_duiM;
  bf_CDUI  *m_duiBackgr;
  bf_CDUI  *m_duiEmoti;
  
  bf_UTL_CDUIR_THMFILE  *m_utl_duir_thmfile;
  bf_CDUIR  *m_duirEmotiSprites;

  bf_CDas_Surface *m_backgr_Srf;
  int m_backgr_mode;
  char *m_backgr_path;

  bf_CARRE m_REGISTER;    //register lietajucich emotikonov

  CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI);
  ~CMyApp();
  void DeleteAllEmoti();
  virtual void Do_LOAD_SRF();
  virtual void Do_RELEASE_SRF();
  virtual void Do_RESTORE_SRF();
  //virtual void Init();
  virtual int SetupVisual();
  void Insert_DUIR_Sprites();
  //virtual void Init2();
  virtual void HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
  virtual bool HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol = NULL);
  virtual void ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new);
  virtual void Redraw_Screen(LPDIRECTDRAWSURFACE p_lpDDS);
  //virtual void DrawCursor(LPDIRECTDRAWSURFACE p_lpDDS);
};


//----------------------------------------------------------------
// Konstruktor
//----------------------------------------------------------------
CMyApp::CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI) : bf_CAppScreen(hInstance, nCmdShow, cLocApp_INI)
{
   m_label_1 = new bf_CLabel(this, -1);
   m_btn_SSF = new bf_CButton(this, IDC_BTN_DLG_SSF);

   m_duiM = new bf_CDUI(this, IDC_DUIM );
   m_duiM->autohide = false;

   m_duiBackgr = new bf_CDUI(this, IDC_DUIB );
   m_duiEmoti  = new bf_CDUI(this, IDC_DUIE );

   m_utl_duir_thmfile = new bf_UTL_CDUIR_THMFILE(this, IDC_DUIR_THM); //UTILS instancia so subormi
   m_utl_duir_thmfile->autohide = true;
   m_utl_duir_thmfile->Rol_poc_zobr = 7;

   m_duirEmotiSprites = new bf_CDUIR(this, IDC_DUIR_SPRITES);
   m_duirEmotiSprites->autohide = true;
   m_duirEmotiSprites->Rol_poc_zobr = 7;    //kolko viditelnych volieb bez rolovania

   m_backgr_Srf = new bf_CDas_Surface();
   m_backgr_mode = 1;
   m_backgr_path = NULL;
};

//----------------------------------------------------------------
// destruktor
//----------------------------------------------------------------
CMyApp::~CMyApp()
{
  DeleteAllEmoti();
};

//----------------------------------------------------------------
// uvolnit vsetky v registri
//----------------------------------------------------------------
void CMyApp::DeleteAllEmoti()
{
  for (int i = 0; i < m_REGISTER.count; i++)
  {
    CEmoticon *emot = (CEmoticon*)m_REGISTER[i];  //i-ty emotikon
    delete emot;
    m_REGISTER.Blenduj(i);
  }
  m_REGISTER.Zhod_count();
};

//----------------------------------------------------------------
// nahratie SRF
//----------------------------------------------------------------
void CMyApp::Do_LOAD_SRF()
{
  emoticons_srf.LOAD_SURFACE((char*) "emoticons.bmp");
  emoticons_srf.BC_SET(0, 0);
  emoticons_srf.TC_SET(3, 3);
};

//----------------------------------------------------------------
// Uvolnit vsetky objekty surfaces
//----------------------------------------------------------------
void CMyApp::Do_RELEASE_SRF()
{
  emoticons_srf.RELEASE_SURFACE();
}

//----------------------------------------------------------------
// Restore objektov surfaces
//----------------------------------------------------------------
void CMyApp::Do_RESTORE_SRF()
{
  emoticons_srf.RESTORE_SURFACE();
}


//----------------------------------------------------------------
// Nastavi vizual, dizajn dialogu
//----------------------------------------------------------------
int CMyApp::SetupVisual()
{
  bf_CAppScreen::SetupVisual(); //obsluzit najprv predka (od koho je App odvodena)
  
  m_label_1->Dsgn(200, 100, (char*)"FlyingEmoti");
  m_label_1->CR_text_color = RGB(100, 180, 100);
  m_label_1->font_hnd = bf_DSGN_CreateFont(75, 40, FW_NORMAL, "Verdana");
  m_label_1->GO_TO_CENTER(bf_Get_SX(), 100);

  m_btn_SSF->Dsgn0_VoidDC(885, 672,   150, 45);   //default: void_SIR = 100; void_VYS = 45;
  m_btn_SSF->Dsgn_label(5, 15, (char*)"Stop/Slow/Fast", RGB(100, 180, 100));
  m_btn_SSF->GO_TO_CENTER(bf_Get_SX(), bf_Get_MAXY()-60);

  m_duiM->DELETE_ALL();
  m_duiM->ADD(1, (char*) "Background");
  m_duiM->ADD(2, (char*) "Emoti sprites");
  m_duiM->RESET_DEFAULT(bf_c_DUI_class_1_HORIZONTAL);
  m_duiM->Join_Master_Detail_popup(1, m_duiBackgr);
  m_duiM->Join_Master_Detail_popup(2, m_duiEmoti);

  m_duiBackgr->DELETE_ALL();
  m_duiBackgr->ADD(1, (char*) "Layout center 1:1");
  m_duiBackgr->ADD(2, (char*) "Layout stretch");
  m_duiBackgr->ADD(3, (char*) "Image...");
  m_duiBackgr->RESET_DEFAULT(bf_c_DUI_class_2_VERTICAL);
  m_duiBackgr->visible = false;
  m_duiBackgr->Join_Master_Detail_popup(3, m_utl_duir_thmfile);

  m_duiEmoti->DELETE_ALL();
  m_duiEmoti->ADD(1, (char*) "Add...");
  m_duiEmoti->ADD(2, (char*) "Delete");
  m_duiEmoti->RESET_DEFAULT(bf_c_DUI_class_2_VERTICAL);
  m_duiEmoti->visible = false;
  m_duiEmoti->Join_Master_Detail_popup(1, m_duirEmotiSprites);

  m_utl_duir_thmfile->XRELOAD((char*) ".\\DATA_BG\\", false);  //nahrat bez transparentnosti //NOTE: tam uz schovane aj bf_BMP_Vytvor__bmp2thm()
  m_utl_duir_thmfile->RESET_DEFAULT(bf_c_DUI_class_2_VERTICAL);
  //m_utl_duir_thmfile->GO_TO_CENTER(bf_Get_SX(), bf_Get_SY());
  m_utl_duir_thmfile->visible = false;

  m_duirEmotiSprites->DELETE_ALL();
  Insert_DUIR_Sprites();
  m_duirEmotiSprites->RESET_DEFAULT();
  m_duirEmotiSprites->visible = false;

  //default pozadie
  bf_TCHOICER *v = m_utl_duir_thmfile->VratVolbu__hodnotovo( 4 );
  if (v != NULL && v->data != NULL)
  {
    m_backgr_path = (char *)v->data;   //nastavit existujuce pozadie
  //m_backgr_Srf->RELEASE_SURFACE();   //uvolnit doterajsie
    m_backgr_Srf->LOAD_SURFACE(m_backgr_path);  //natiahnut nove
  }
  m_backgr_Srf->TC = 0;   //netransparentne

  //default sprite
  //srand((unsigned)time(NULL));
  v = m_duirEmotiSprites->VratVolbu__hodnotovo( 1 );
  if (v != NULL)
  {
    CEmoticon *emot = new CEmoticon(v->p_icon);  //podla ikony vzoru (srf+faza) vytvorit instanciu
    m_REGISTER.ADD(emot);  //pridat do kolekcie
  }

  return 0;
}

//----------------------------------------------------------------
void CMyApp::Insert_DUIR_Sprites()
{
  m_duirEmotiSprites->ADD(1, (char*) "Emoticon 1", new bf_CIcon(&emoticons_srf, 30, 30), true);
  m_duirEmotiSprites->ADD(2, (char*) "Emoticon 2", new bf_CIcon(&emoticons_srf, 100, 30), true);
  m_duirEmotiSprites->ADD(3, (char*) "Emoticon 3", new bf_CIcon(&emoticons_srf, 170, 30), true);
  m_duirEmotiSprites->ADD(4, (char*) "Emoticon 4", new bf_CIcon(&emoticons_srf, 240, 30), true);
  m_duirEmotiSprites->ADD(5, (char*) "Emoticon 5", new bf_CIcon(&emoticons_srf, 30, 100), true);
  m_duirEmotiSprites->ADD(6, (char*) "Emoticon 6", new bf_CIcon(&emoticons_srf, 100, 100), true);
  m_duirEmotiSprites->ADD(7, (char*) "Emoticon 7", new bf_CIcon(&emoticons_srf, 170, 100), true);
  m_duirEmotiSprites->ADD(8, (char*) "Emoticon 8", new bf_CIcon(&emoticons_srf, 240, 100), true);
  m_duirEmotiSprites->ADD(9, (char*) "Emoticon 9", new bf_CIcon(&emoticons_srf, 30, 160), true);
  m_duirEmotiSprites->ADD(10, (char*) "Emoticon 10", new bf_CIcon(&emoticons_srf, 100, 160), true);
  m_duirEmotiSprites->ADD(11, (char*) "Emoticon 11", new bf_CIcon(&emoticons_srf, 170, 160), true);
  m_duirEmotiSprites->ADD(12, (char*) "Emoticon 12", new bf_CIcon(&emoticons_srf, 240, 160), true);
  m_duirEmotiSprites->ADD(13, (char*) "Emoticon 13", new bf_CIcon(&emoticons_srf, 30, 220), true);
  m_duirEmotiSprites->ADD(14, (char*) "Emoticon 14", new bf_CIcon(&emoticons_srf, 100, 220), true);
  m_duirEmotiSprites->ADD(15, (char*) "Emoticon 15", new bf_CIcon(&emoticons_srf, 170, 220), true);
  m_duirEmotiSprites->ADD(16, (char*) "Emoticon 16", new bf_CIcon(&emoticons_srf, 240, 220), true);
}

//----------------------------------------------------------------
// Spracovanie WM 
//----------------------------------------------------------------
void CMyApp::HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  int mx,my;
  switch (message)
  {
  case WM_RBUTTONDOWN:      //pravy klik mysou DOWN
    mx = LOWORD(lParam);
    my = HIWORD(lParam);
    //m_DemoDLG->GO_TO_CENTER(mx, my);
    pravedole = true;
    break;

  case WM_RBUTTONUP:      //pravy klik mysou UP
    pravedole = false;
    break;

  case WM_MOUSEMOVE:
    if ( pravedole )
    {
      mx = LOWORD(lParam);
      my = HIWORD(lParam);
      //m_DemoDLG->GO_TO_CENTER(mx, my);
    }
    break;
  }
}

//----------------------------------------------------------------
// Da priestor na akciu 
//----------------------------------------------------------------
bool CMyApp::HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol)
{
  //postup cez dimenziu predkov
  bool l_b = bf_CAppScreen::HandleFWInteraction(iID, ivalue, p_pol);  //obsluzit class predka
   
  bf_TCHOICER *v;

  switch (iID)
  {
  case IDC_BTN_DLG_SSF:    //rotacia 3 stavov tlacidla 1/2/3
    status_SSF++;
    if (status_SSF>3) status_SSF = 1;
    break;

  case IDC_DUIB:
    if (ivalue == 1) m_backgr_mode = 1;
    if (ivalue == 2) m_backgr_mode = 2;
    break;

  case IDC_DUIR_THM:
    v = m_utl_duir_thmfile->VratVolbu__hodnotovo(ivalue);
    if (v != NULL && v->data != NULL)
    {
      m_backgr_path = (char *)v->data;   //nastavit existujuce pozadie
      m_backgr_Srf->RELEASE_SURFACE();   //uvolnit doterajsie
      m_backgr_Srf->LOAD_SURFACE(m_backgr_path);  //natiahnut nove
    }
    else
    {
      m_backgr_path = NULL;
    }
    break;

  case IDC_DUIR_SPRITES:
    v = m_duirEmotiSprites->VratVolbu__hodnotovo(ivalue);
    if (v != NULL )
    {
      int poc = m_REGISTER.count;
      if (poc < 1000)
        for (int i = 0; i < poc; i++)
        {
          CEmoticon *emot = new CEmoticon(v->p_icon);  //podla ikony vzoru (srf+faza) vytvorit instanciu
          m_REGISTER.ADD(emot);  //pridat do kolekcie
         }
    }
    break;

  case IDC_DUIE:
    if ( ivalue == 2 )  //ak Delete volba
    {
      DeleteAllEmoti();
      //default sprite
      v = m_duirEmotiSprites->VratVolbu__hodnotovo(1);
      if (v != NULL)
      {
        CEmoticon *emot = new CEmoticon(v->p_icon);  //podla ikony vzoru (srf+faza) vytvorit instanciu
        m_REGISTER.ADD(emot);  //pridat do kolekcie
      }
    }
    break;

  }

  return l_b;
}

//----------------------------------------------------------------
// Volane po zmene rozmerov obrazovky
//----------------------------------------------------------------
void CMyApp::ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new)
{
  //postup cez dimenziu predkov (vratit funkcnost predkovi, lebo cez virtual bola obidena, prepisana)
  bf_CAppScreen::ChangedResolution(maxx_old, maxy_old, maxx_new, maxy_new);  //obsluzit class predka

  m_label_1->GO_TO_CENTER(bf_Get_SX(), 100);
  m_btn_SSF->GO_TO_CENTER(bf_Get_SX(), bf_Get_MAXY() - 60);
  m_duiM->RESET_DEFAULT(bf_c_DUI_class_1_HORIZONTAL);

  m_backgr_Srf->RELOAD_SURFACE();

  m_utl_duir_thmfile->XRELOAD((char*) ".\\DATA_BG\\", false);
}

//----------------------------------------------------------------
// Prekreslit celu scenu 
//----------------------------------------------------------------
void CMyApp::Redraw_Screen(LPDIRECTDRAWSURFACE p_lpDDS)
{
  //<--- vymazat
  //DDSURFACE_ZMAZ(p_lpDDS, 500);
  //emoticons_srf.DRAW(5, 200);

  if (m_backgr_mode == 1) //1:1 center 
    m_backgr_Srf->Draw_Center();
  else if (m_backgr_mode == 2) //stretch
     //m_backgr_Srf->DRAW(0, 0);
    m_backgr_Srf->Draw_Stretch_4();

  for (int i = 0; i < m_REGISTER.count; i++)
  {
    CEmoticon *emot = (CEmoticon*)m_REGISTER[i];  //i-ty emotikon
    if (status_SSF != 1) //nie je stop
      emot->Activate();
    emot->DRAW();
  }
}

/*
//----------------------------------------------------------------
// Vykreslit kurzor
//----------------------------------------------------------------
void CMyApp::DrawCursor(LPDIRECTDRAWSURFACE p_lpDDS)
{
}
*/

//==============================================================================

//----------------------------------------------------------------
// Vstupny bod pre Appku
//----------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
  //bf_Set_Lang(bf_c_Lang_EN);
  CMyApp *pAPP = new CMyApp(hInstance, nCmdShow, (char*) "EXAMPLE.INI");    //vytvorit instanciu
  pAPP->SetBackground(500, (char*)"", false);   //tmavomodra farba pozadia, ziaden obraz ako podklad, ziadne logo
  pAPP->SetAppInfo((char*)"Example, FlyingEmoti", (char*)"(version: 1.0)", (char*)"Branislav Lehotsk");  //info polia
  pAPP->SetLang( bf_c_Lang_EN );   // bf_c_Lang_EN / bf_c_Lang_SK 
  pAPP->Execute();  //spustit
  delete pAPP;
  return 0;
}
