/*==========================================================================
*
*  Example_1 - demo application
*  by Branislav Lehotsky
*  Demonstration of using BonbliotFramework (c)
*  - is showing background and flying sprites, parametrisation via menu 
*
*  Example_1 - demontran apka
*  Branislav Lehotsk
*  Demontruje pouitie BonbliotFramework (c)
*  - zobraz pozadie a lietajce sprajty, parametrizacia cez menu
*
*==========================================================================
*/
#include <ddraw.h>     //Direct Draw 
#include <mmsystem.h>  //koli LPWAVEFORMATEX v <dsound.h> a.i.
#include <dsound.h>    //Direct Sound

#include <stdio.h>     //koli fopen()...

//---------------------- //hlavicka hlavnej kniznice, FrameWork by Bonbliot (c)
//#include "..\_BonbliotFramework_v3_1\DBonbliotFW.h"
#include "DBonbliotFW.h"    
//----------------------

#define IDC_BTN_DLG_SSF    100

#define IDC_DUIM           207
#define IDC_DUIB           208
#define IDC_DUIS           209
#define IDC_DUIR_THM       210
#define IDC_DUIR_SPRITES   211

bool pravedole;

int status_SSF = 3;    //stav tlacitka stop/slow/fast

bf_CDas_Surface srf_Bird;
bf_CDas_Surface srf_Dog;
bf_CDas_Surface srf_LH;

bf_CDAS das_Bird;
bf_CDAS das_Dog;
bf_CDAS das_LH;

//----------------------------------------------------------------
// Nahodne cislo <min,max>
//----------------------------------------------------------------
int Get_Random(int min, int max)
{
  return min + int( (double(rand()) / RAND_MAX) * (max - min) );   //nahodne cislo <min,max>
}

//----------------------------------------------------------------
// Nacitanie faz z parametrickeho subora *.faz 
//----------------------------------------------------------------
void Load_Fazy(char *sub_nazov, bf_CDAS *pDas)
{
  FILE *F;
  char riadok[400];  //na nacitavanie riadkov subora
  int xx, yy;
  int i;

  if (pDas == NULL)
    return;

  //F = fopen(sub_nazov, "rt");
  fopen_s(&F, sub_nazov, "rt");

  if (F == NULL)  //toto by sa nemalo stat ak ma sprite viacere fazy
  {	
    //bf_LOGT("P_Load_Fazy: Subor neexistuje => EVIDUJ_CS()", sub_nazov); //<<<<<< DEBUG
    pDas->REGISTER_CS();
    return;
  };

  //bf_LOGT("P_Load_Fazy: Nacitavam zo subora:", sub_nazov);  //<<<<<< DEBUG
  i = 0;
  while (!feof(F))
  {
    i++;
    fgets(riadok, 400, F);
    //sscanf(riadok, "%i %i", &xx, &yy);
    sscanf_s(riadok, "%i %i", &xx, &yy);
    //bf_LOG3("P_Load_Fazy - faza", i, xx, yy);  //<<<<<< DEBUG
    pDas->REGISTER(xx, yy);
  }
  fclose(F);

  pDas->vx = 3;
}


//----------------------------------------------------------------
// CMyDAS_2
//----------------------------------------------------------------
class CMyDAS_2 : public bf_CDAS
{
public:
  int anim_delay;
  int counter;

  CMyDAS_2(int xx = 100, int yy = 500, int vvx = 2);
  void Activate();
};

//----------------------------------------------------------------
// Konstruktor
//----------------------------------------------------------------
CMyDAS_2::CMyDAS_2(int xx /*= 100*/, int yy /*= 500*/, int vvx /*= 2*/) : bf_CDAS(xx, yy)
{
    vx = vvx;
    anim_delay = 6; //default
    counter = anim_delay;
}

//----------------------------------------------------------------
// Aktivacia, krok
//----------------------------------------------------------------
void CMyDAS_2::Activate()
{
  if (status_SSF != 1)  //non stop
    counter--;
  
  if (counter <= 0 )
  {
    NF();  //na dalsiu fazu
    if (status_SSF == 2) //slow
      counter = anim_delay * 3;
    else if (status_SSF == 3) //fast
      counter = anim_delay;
  }

  int test_sir = ((bf_TPHASE*) FAZY[akt_faza])->SIR;
  //int test_vys = FAZY[akt_faza].VYS;
  int maxx = bf_Get_MAXX();
  //int maxy = bf_Get_MAXY();

  if (status_SSF == 3) x += vx; //fast
  else if (status_SSF == 2) x += vx/2; //slow
  if (x > (maxx - test_sir)) { x = maxx - test_sir; vx = -vx; zrkadlo = 1; };
  if (x < 0) { x = 0; vx = -vx; zrkadlo = 0; };
  //y += vy;
  //if (y > (maxy - test_vys)) { y = maxy - test_vys; vy = -vy; };
  //if (y < 0) { y = 0; vy = -vy; };
}


//----------------------------------------------------------------
// App
//----------------------------------------------------------------
class CMyApp : public bf_CAppScreen
{
public:
  bf_CButton * m_btn_SSF;
  bf_CLabel * m_label_1;

  bf_CDUI  *m_duiM;
  bf_CDUI  *m_duiBackgr;
  bf_CDUI  *m_duiSprites;
  
  bf_UTL_CDUIR_THMFILE  *m_utl_duir_thmfile_Backgr;
  bf_CDUIR  *m_duirSpritesAdd;

  bf_CDas_Surface *m_backgr_Srf;
  int m_backgr_mode;
  char *m_backgr_path;

  bf_CARRE m_REGISTER;    //register lietajucich spritov

  CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI);
  ~CMyApp();
  void DeleteAllRegister();
  virtual void Do_LOAD_SRF();
  virtual void Do_RELEASE_SRF();
  virtual void Do_RESTORE_SRF();
  //virtual void Init();
  virtual int SetupVisual();
  //virtual void Init2();
  virtual void HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
  virtual bool HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol = NULL);
  virtual void ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new);
  virtual void Redraw_Screen(LPDIRECTDRAWSURFACE p_lpDDS);
  //virtual void DrawCursor(LPDIRECTDRAWSURFACE p_lpDDS);
};


//----------------------------------------------------------------
// Konstruktor
//----------------------------------------------------------------
CMyApp::CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI) : bf_CAppScreen(hInstance, nCmdShow, cLocApp_INI)
{
   m_label_1 = new bf_CLabel(this, -1);
   m_btn_SSF = new bf_CButton(this, IDC_BTN_DLG_SSF);

   m_duiM = new bf_CDUI(this, IDC_DUIM );
   m_duiM->autohide = false;

   m_duiBackgr = new bf_CDUI(this, IDC_DUIB );
   m_duiSprites  = new bf_CDUI(this, IDC_DUIS );

   m_utl_duir_thmfile_Backgr = new bf_UTL_CDUIR_THMFILE(this, IDC_DUIR_THM); //UTILS instancia so subormi
   m_utl_duir_thmfile_Backgr->autohide = true;
   m_utl_duir_thmfile_Backgr->Rol_poc_zobr = 7;

   m_duirSpritesAdd = new bf_CDUIR(this, IDC_DUIR_SPRITES);
   m_duirSpritesAdd->autohide = true;
   m_duirSpritesAdd->Rol_poc_zobr = 7;    //kolko viditelnych volieb bez rolovania

   m_backgr_Srf = new bf_CDas_Surface();
   m_backgr_mode = 1;
   m_backgr_path = NULL;
};

//----------------------------------------------------------------
// destruktor
//----------------------------------------------------------------
CMyApp::~CMyApp()
{
  DeleteAllRegister();
};

//----------------------------------------------------------------
// uvolnit vsetky v registri
//----------------------------------------------------------------
void CMyApp::DeleteAllRegister()
{
  for (int i = 0; i < m_REGISTER.count; i++)
  {
    CMyDAS_2 *das = (CMyDAS_2*)m_REGISTER[i];  //i-ty sprite
    delete das;

    m_REGISTER.Blenduj(i);
  }
  m_REGISTER.Zhod_count();
};

//----------------------------------------------------------------
// nahratie SRF
//----------------------------------------------------------------
void CMyApp::Do_LOAD_SRF()
{
    srf_Bird.LOAD_SURFACE((char*) ".\\DATA_DAS\\BIRD.BMP");
    srf_Bird.TC_SET(6, 6);       //transparent color
    srf_Bird.BC_SET(0, 0);       //boundary color 

    srf_Dog.LOAD_SURFACE((char*) ".\\DATA_DAS\\DOG.BMP");
    srf_Dog.TC_SET(6, 6);       //transparent color
    srf_Dog.BC_SET(0, 0);       //boundary color 

    srf_LH.LOAD_SURFACE((char*) ".\\DATA_DAS\\LH.BMP");
    srf_LH.TC_SET(6, 6);       //transparent color
    srf_LH.BC_SET(0, 0);       //boundary color 
};

//----------------------------------------------------------------
// Uvolnit vsetky objekty surfaces
//----------------------------------------------------------------
void CMyApp::Do_RELEASE_SRF()
{
    //m_backgr_Srf->RELEASE_SURFACE();
    srf_Bird.RELEASE_SURFACE();
    srf_Dog.RELEASE_SURFACE();
    srf_LH.RELEASE_SURFACE();
}

//----------------------------------------------------------------
// Restore objektov surfaces
//----------------------------------------------------------------
void CMyApp::Do_RESTORE_SRF()
{
    //m_backgr_Srf->RESTORE_SURFACE();
    srf_Bird.RESTORE_SURFACE();
    srf_Dog.RESTORE_SURFACE();
    srf_LH.RESTORE_SURFACE();
}

//----------------------------------------------------------------
// Nastavi vizual, dizajn dialogu
//----------------------------------------------------------------
int CMyApp::SetupVisual()
{
  bf_CAppScreen::SetupVisual(); //obsluzit najprv predka (od koho je App odvodena)
  
  m_label_1->Dsgn(200, 100, (char*)"DAS Demo");
  m_label_1->CR_text_color = RGB(100, 180, 100);
  m_label_1->font_hnd = bf_DSGN_CreateFont(75, 40, FW_NORMAL, "Verdana");
  m_label_1->GO_TO_CENTER(bf_Get_SX(), 100);

  m_btn_SSF->Dsgn0_VoidDC(885, 672,   150, 45);   //default: void_SIR = 100; void_VYS = 45;
  m_btn_SSF->Dsgn_label(5, 15, (char*)"Stop/Slow/Fast", RGB(100, 180, 100));
  m_btn_SSF->GO_TO_CENTER(bf_Get_SX(), bf_Get_MAXY()-60);

  m_duiM->DELETE_ALL();
  m_duiM->ADD(1, (char*) "Background");
  m_duiM->ADD(2, (char*) "Sprites");
  m_duiM->RESET_DEFAULT(bf_c_DUI_class_1_HORIZONTAL);
  m_duiM->Join_Master_Detail_popup(1, m_duiBackgr);
  m_duiM->Join_Master_Detail_popup(2, m_duiSprites);

  m_duiBackgr->DELETE_ALL();
  m_duiBackgr->ADD(1, (char*) "Layout center 1:1");
  m_duiBackgr->ADD(2, (char*) "Layout stretch");
  m_duiBackgr->ADD(3, (char*) "Image...");
  m_duiBackgr->RESET_DEFAULT(bf_c_DUI_class_2_VERTICAL);
  m_duiBackgr->visible = false;
  m_duiBackgr->Join_Master_Detail_popup(3, m_utl_duir_thmfile_Backgr);

  m_duiSprites->DELETE_ALL();
  m_duiSprites->ADD(1, (char*) "Add...");
  m_duiSprites->ADD(2, (char*) "Delete");
  m_duiSprites->RESET_DEFAULT(bf_c_DUI_class_2_VERTICAL);
  m_duiSprites->visible = false;
  m_duiSprites->Join_Master_Detail_popup(1, m_duirSpritesAdd);

  m_utl_duir_thmfile_Backgr->XRELOAD((char*) ".\\DATA_BG\\", false);  //nahrat bez transparentnosti //NOTE: tam uz schovane aj bf_BMP_Vytvor__bmp2thm()
  m_utl_duir_thmfile_Backgr->RESET_DEFAULT(bf_c_DUI_class_2_VERTICAL);
  m_utl_duir_thmfile_Backgr->visible = false;

  //doplnit v zadanom foldri THM pre tie BMP, ktore este nemaju (ak su take)	
  int thm_sir = 100;
  int thm_vys = 60;
    //----------------------
  if (bf_BMP_Vytvor__bmp2thm( (char*)".\\DATA_DAS\\", thm_sir, thm_vys, 1) != 0)
    //----------------------
  {
    bf_LOGT("Doslo k chybe pri vytvarani THM suborov", "X");
    assert(0);
  }

  m_duirSpritesAdd->DELETE_ALL();
  m_duirSpritesAdd->ADD(1, (char*) "Bird", new bf_CIcon((char*)".\\DATA_DAS\\BIRD.thm"), true);
  m_duirSpritesAdd->ADD(2, (char*) "Dog", new bf_CIcon((char*)".\\DATA_DAS\\DOG.thm"), true);
  m_duirSpritesAdd->ADD(3, (char*) "L&H", new bf_CIcon((char*)".\\DATA_DAS\\LH.thm"), true);
  m_duirSpritesAdd->RESET_DEFAULT();
  m_duirSpritesAdd->visible = false;

  //default pozadie
  bf_TCHOICER *v = m_utl_duir_thmfile_Backgr->VratVolbu__hodnotovo( 4 );
  if (v != NULL && v->data != NULL)
  {
    m_backgr_path = (char *)v->data;   //nastavit existujuce pozadie
  //m_backgr_Srf->RELEASE_SURFACE();   //uvolnit doterajsie
    m_backgr_Srf->LOAD_SURFACE(m_backgr_path);  //natiahnut nove
  }
  m_backgr_Srf->TC = 0;   //netransparentne

  //--- 3x default sprites
  //srf_Bird.LOAD_SURFACE( (char*) ".\\DATA_DAS\\BIRD.BMP" );   //toto je presunute do Do_LOAD_SRF()
  //srf_Bird.TC_SET(6, 6);       //transparent color
  //srf_Bird.BC_SET(0, 0);       //boundary color 
  das_Bird.Das_Surface = &srf_Bird;
  das_Bird.srf_vlastnik = false;  //not owner
    //manualne
    das_Bird.REGISTER(10,10);
    das_Bird.REGISTER(80,10);
    das_Bird.REGISTER(150,10);
    das_Bird.REGISTER(210, 10);
    das_Bird.REGISTER(270, 10);
    das_Bird.REGISTER(10, 60);
    das_Bird.REGISTER(80, 60);
    das_Bird.REGISTER(150, 60);
    das_Bird.REGISTER(210, 60);
    das_Bird.REGISTER(270, 60);
  das_Bird.GO_TO(280, 130);

  //srf_Dog.LOAD_SURFACE((char*) ".\\DATA_DAS\\DOG.BMP");  //toto je presunute do Do_LOAD_SRF()
  //srf_Dog.TC_SET(6, 6);       //transparent color
  //srf_Dog.BC_SET(0, 0);       //boundary color 
  das_Dog.Das_Surface = &srf_Dog;
  das_Dog.srf_vlastnik = false;   //not owner
  Load_Fazy( (char*)".\\DATA_DAS\\DOG.faz", &das_Dog); //funkcne
  das_Dog.GO_TO(250, 210);

  //srf_LH.LOAD_SURFACE((char*) ".\\DATA_DAS\\LH.BMP");  //toto je presunute do Do_LOAD_SRF()
  //srf_LH.TC_SET(6, 6);       //transparent color
  //srf_LH.BC_SET(0, 0);       //boundary color 
  das_LH.Das_Surface = &srf_LH;
  das_LH.srf_vlastnik = false;   //not owner
  Load_Fazy((char*)".\\DATA_DAS\\LH.faz", &das_LH); //funkcne
  das_LH.GO_TO(50, 100);

  return 0;
}

//----------------------------------------------------------------
// Spracovanie WM 
//----------------------------------------------------------------
void CMyApp::HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  /*
  int mx,my;
  switch (message)
  {
  case WM_RBUTTONDOWN:      //pravy klik mysou DOWN
    mx = LOWORD(lParam);
    my = HIWORD(lParam);
    pravedole = true;
    break;

  case WM_RBUTTONUP:      //pravy klik mysou UP
    pravedole = false;
    break;

  case WM_MOUSEMOVE:
    if ( pravedole )
    {
      mx = LOWORD(lParam);
      my = HIWORD(lParam);
    }
    break;
  }
  */
}

//----------------------------------------------------------------
// Da priestor na akciu 
//----------------------------------------------------------------
bool CMyApp::HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol)
{
  //postup cez dimenziu predkov
  bool l_b = bf_CAppScreen::HandleFWInteraction(iID, ivalue, p_pol);  //obsluzit class predka
   
  bf_TCHOICER *v;

  CMyDAS_2 *Das;

  switch (iID)
  {
  case IDC_BTN_DLG_SSF:    //rotacia 3 stavov tlacidla 1/2/3
    status_SSF++;
    if (status_SSF>3) status_SSF = 1;
    break;

  case IDC_DUIB:
    if (ivalue == 1) m_backgr_mode = 1;
    if (ivalue == 2) m_backgr_mode = 2;
    break;

  case IDC_DUIR_THM:
    v = m_utl_duir_thmfile_Backgr->VratVolbu__hodnotovo(ivalue);
    if (v != NULL && v->data != NULL)
    {
      m_backgr_path = (char *)v->data;   //nastavit existujuce pozadie
      m_backgr_Srf->RELEASE_SURFACE();   //uvolnit doterajsie
      m_backgr_Srf->LOAD_SURFACE(m_backgr_path);  //natiahnut nove
    }
    else
    {
      m_backgr_path = NULL;
    }
    break;

  case IDC_DUIR_SPRITES:   //pridavame dalsi sprite 
    Das = new CMyDAS_2( 100, Get_Random(300, bf_Get_MAXY()-100), Get_Random(2,8) );  //nova instancia  CMyDAS_2
    switch (ivalue)
    {
      case 1:
        Das->REGISTER_COPY(&das_Bird);
        Das->anim_delay = 5;
        break;
      case 2:
        Das->REGISTER_COPY(&das_Dog);
        Das->anim_delay = 2;
        break;
      case 3:
        Das->REGISTER_COPY(&das_LH);
        Das->anim_delay = 6;
        break;
    }
    m_REGISTER.ADD(Das);  //pridat do kolekcie
    break;

  case IDC_DUIS:
    if ( ivalue == 2 )  //ak Delete volba
    {
      DeleteAllRegister();
    }
    break;

  }

  return l_b;
}

//----------------------------------------------------------------
// Volane po zmene rozmerov obrazovky
//----------------------------------------------------------------
void CMyApp::ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new)
{
  //postup cez dimenziu predkov (vratit funkcnost predkovi, lebo cez virtual bola obidena, prepisana)
  bf_CAppScreen::ChangedResolution(maxx_old, maxy_old, maxx_new, maxy_new);  //obsluzit class predka

  m_label_1->GO_TO_CENTER(bf_Get_SX(), 100);
  m_btn_SSF->GO_TO_CENTER(bf_Get_SX(), bf_Get_MAXY() - 60);
  m_duiM->RESET_DEFAULT(bf_c_DUI_class_1_HORIZONTAL);

  m_backgr_Srf->RELOAD_SURFACE();

  m_utl_duir_thmfile_Backgr->XRELOAD((char*) ".\\DATA_BG\\", false);

  /* TODO!?
  srf_Bird.RELOAD_SURFACE();
  srf_Dog.RELOAD_SURFACE();
  srf_LH.RELOAD_SURFACE();
  */
  /* nie, pada 
  //prechod, reload poloziek
  for (int i = 0; i < m_duirSpritesAdd->VOLR.count; i++)
  {
    bf_TCHOICER *vr = (bf_TCHOICER*)m_duirSpritesAdd->VOLR[i];  //i-ta volba
    if (vr->p_icon != NULL)  //ikona
      vr->p_icon->Das_Surface->RELOAD_SURFACE();
  }
  */
  //alternativne
  m_duirSpritesAdd->DELETE_ALL();
  m_duirSpritesAdd->ADD(1, (char*) "Bird", new bf_CIcon((char*)".\\DATA_DAS\\BIRD.thm"), true);
  m_duirSpritesAdd->ADD(2, (char*) "Dog", new bf_CIcon((char*)".\\DATA_DAS\\DOG.thm"), true);
  m_duirSpritesAdd->ADD(3, (char*) "L&H", new bf_CIcon((char*)".\\DATA_DAS\\LH.thm"), true);
  //m_duirSpritesAdd->RESET_DEFAULT();
  //m_duirSpritesAdd->visible = false;
}

//----------------------------------------------------------------
// Prekreslit celu scenu 
//----------------------------------------------------------------
void CMyApp::Redraw_Screen(LPDIRECTDRAWSURFACE p_lpDDS)
{
  //<--- vymazat
  //DDSURFACE_ZMAZ(p_lpDDS, 500);

  if (m_backgr_mode == 1) //1:1 center 
    m_backgr_Srf->Draw_Center();
  else if (m_backgr_mode == 2) //stretch
     //m_backgr_Srf->DRAW(0, 0);
    m_backgr_Srf->Draw_Stretch_4();

  for (int i = 0; i < m_REGISTER.count; i++)
  {
    CMyDAS_2 *das = (CMyDAS_2*)m_REGISTER[i];  //i-ty sprite
    das->Activate();
    das->DRAW(p_lpDDS);
  }

  //---
  if (status_SSF != 1)
  {
    das_Bird.NF();   //dalsia faza
    das_Dog.NF();
    das_LH.NF();
  }

  das_Bird.DRAW(p_lpDDS /*m_lpDDSBack*/);
  das_Dog.DRAW(p_lpDDS /*m_lpDDSBack*/);
  das_LH.DRAW(p_lpDDS /*m_lpDDSBack*/);
}

/*
//----------------------------------------------------------------
// Vykreslit kurzor
//----------------------------------------------------------------
void CMyApp::DrawCursor(LPDIRECTDRAWSURFACE p_lpDDS)
{
}
*/

//==============================================================================

//----------------------------------------------------------------
// Vstupny bod pre Appku
//----------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
  CMyApp *pAPP = new CMyApp(hInstance, nCmdShow, (char*) "EXAMPLE.INI");    //vytvorit instanciu
  pAPP->SetBackground(500, (char*)"", false);   //tmavomodra farba pozadia, ziaden obraz ako podklad, ziadne logo
  pAPP->SetAppInfo((char*)"Example, DAS Demo", (char*)"(version: 1.0)", (char*)"Branislav Lehotsk");  //info polia
  pAPP->SetLang( bf_c_Lang_EN );   // bf_c_Lang_EN / bf_c_Lang_SK 
  pAPP->Execute();  //spustit
  delete pAPP;
  return 0;
}
